#ifndef GGAP_APP_H
#define GGAP_APP_H

#include <QDir>
#include <QUrl>
#include <QStringList>
#include <QApplication>
#include <moo/app.h>

class QFile;
class QSettings;
class QCloseEvent;

namespace ggap {

class App : public moo::App {
    Q_OBJECT

public:
    App(int &argc, char **argv);
    ~App();
    int exec ();

    static void parseOptions(int &argc, char **argv);
    static QByteArray serializeCommandLine();

public Q_SLOTS:
    virtual void aboutDialog();
    virtual void prefsDialog();
    void gapHelp(const QUrl &url = QUrl());
    void messageReceived(const QByteArray &message);

    void forceActivate(QWidget *window = 0);

private:
    void checkGap();
    virtual void loadFile(const QString &filename);
    void runScript(const QString &script);
    void doAppMsg(const QByteArray &data);
};

#define gapApp (static_cast<ggap::App*>(QCoreApplication::instance()))

} // namespace ggap

#endif // GGAP_APP_H
